
//see http://ss.deviatenow.com/viewtopic.php?f=7&t=123

setInfos(3, "Schoolscript", "", "Sub101, Doti, Zoey", "Base, some intro but no courses...just for test", 0xFFFFFF, "en", []);

if(loadString("schoolscript.timing")==null)
	return "schoolscript/firstrun";
def now = Calendar.getInstance()
def timing = loadString("schoolscript.timing")
def start = loadInteger("schoolscript.startTime")
def minutesLate = 0
// themes, including last exam of each one (n) and a last theme
/*
def allSubjects = [["name":"math","n":4, ["name":"domestic science","n":4], 
	["name":"biology","n":4], ["name":"physics","n":4], ["name":"sport","n":3], 
	["name":"english","n":3], ["name":"religion","n":3], ["name":"chemistry","n":0], 
	["name":"history","n":2], ["name":"geography","n":2], ["name":"stage", "n":2]]
*/
def allSubjects = [["name":"geography","n":1],["name":"stage","n":1]]

def nbLessons = 0
allSubjects.each{ nbLessons+=it["n"]}
// a sequence finishes by a general lesson, last one is for diploma 
def sequenceLength = (int)(nbLessons / allSubjects.last()["n"])
def longuest = 0
allSubjects.eachWithIndex{ it, i -> if(allSubjects[longuest]["n"]<it["n"])longuest=i}
// number of lesson (0...) => subject and number (0..) in this subject
def getLesson = {nl -> 
	def i = 0
	allSubjects.each{ it["done"] = 0 }
	def res = null
	while(nl>=0) {
		if(i%sequenceLength == sequenceLength-1) {
			if(nl==0) {
				res = ["subject":allSubjects.last()["name"],"number":allSubjects.last()["done"]]
			}
			allSubjects.last()["done"]++
			nl--
		} else {
			allSubjects.subList(0,allSubjects.size()-1).each{ 
				if(it["n"]>it["done"] && 
						it["n"]-it["done"]>=(allSubjects[longuest]["n"]-allSubjects[longuest]["done"])/2) {
					if(nl==0) {
						res = ["subject":it["name"],"number":it["done"]]
					}
					it["done"]++
					nl--
				}
			}	
		}
		i++
	} 
	res
}

setImage(null)
def doneLessons = loadInteger("schoolscript.doneLessons")
def lesson = null
if(timing=="free") {
	// let say start at x:00, x:20, x:40 ; it'll look like random for free lessons
	// then 5 minutes late ... 15 minute early
	def c = Calendar.getInstance()
	minutesLate = ((15+c.get(Calendar.MINUTE))%20) - 15
	lesson = getLesson(doneLessons)		
} else {
	def planning = []
	if(timing=="weekends") {
		def c = Calendar.getInstance()
		c.setTimeInMillis(((long)start)*1000)
		for(def i = 0;i<nbLessons;i++) {
			planning.add(["calendar":c.clone(),"lesson":getLesson(i)])
			c.add(Calendar.MINUTE, 30)
			if(c.get(Calendar.HOUR_OF_DAY)==18) {
				c.set(Calendar.HOUR_OF_DAY, 14)
				if(c.get(Calendar.DAY_OF_WEEK)==7)
					c.set(Calendar.DAY_OF_WEEK,1)
				else
					c.set(Calendar.DAY_OF_WEEK,7)
			}
		}
	} else {
		def c = Calendar.getInstance()
		c.setTimeInMillis(((long)start)*1000)
		for(def i = 0;i<nbLessons;i++) {
			planning.add(["calendar":c.clone(),"lesson":getLesson(i)])
			c.add(Calendar.MINUTE, 30)
			if(c.get(Calendar.HOUR_OF_DAY)==21) {
				c.set(Calendar.HOUR_OF_DAY, 19)
				if(c.get(Calendar.DAY_OF_WEEK)==6)
					c.add(Calendar.DAY_OF_WEEK,3)
				else
					c.add(Calendar.DAY_OF_WEEK,1)
			}
		}		
	}
	def seeSchedule = !getBoolean("Next to the classroom","Enter","See schedule on board")
	if(!seeSchedule) { //enter classroom 
		def lastLessonEnd = null
		for(def p : planning) {
			def realStart = p["calendar"].clone()
			realStart.add(Calendar.MINUTE,-15) //early, see below
			//at 2 minute of the end, forget it
			def realEnd = p["calendar"].clone()
			realEnd.add(Calendar.MINUTE,28) 
			if(lesson == null && realStart.before(now) && realEnd.after(now)) {				
				lesson = p["lesson"]				
				minutesLate = (int)((now.getTime().getTime() - p["calendar"].getTime().getTime())/1000/60)
			}
			lastLessonEnd = realEnd
		}
		if(lesson==null) {
			if(lastLessonEnd.before(now)) {
				show("It looks like nobody awaited you. You'll have to apply again.")
				save("schoolscript.timing",null)
				save("schoolscript.startTime",null)
				return ;
			} else {
				show("Perhaps you made a mistake, there's no lesson for now.")
				showButton("Really ?")
				show("Let see the schedule...")
				wait(2)
				seeSchedule = true
			}
		}
	}
	if(seeSchedule) {
		def lastDay = 0
		def s = "<b>Schedule</b>\n"
		for(def p : planning) {
			def day = p["calendar"].get(Calendar.DAY_OF_MONTH)			
			def month = p["calendar"].get(Calendar.MONTH)+1
			if(lastDay != day)
				s += "\n ** "+day+"/"+month+" **\n| "
			s += String.format("%02d:%02d %s %d | ",
					p["calendar"].get(Calendar.HOUR_OF_DAY),
					p["calendar"].get(Calendar.MINUTE),
				p["lesson"]["subject"],p["lesson"]["number"]+1)
			lastDay = day
		}
		s+="\n\nAttenance to all lessons is mandatory"
		show(s)
		return "schoolscript"			
	}
}

//read this in specific script
save("schoolscript.subject",lesson["subject"])
save("schoolscript.lessonNumber",lesson["number"])
save("schoolscript.minutesLate",minutesLate)

// too early : -14...-5
// normal : -5...0
// manage this in specific lesson (punition ?) : 0..30
if(minutesLate<-5) 
	return "schoolscript/early"
else
	return "schoolscript/"+lesson["subject"]

/*
 * Resources
 * scripts/schoolscript.groovy
 * scripts/schoolscript/early.groovy
 * scripts/schoolscript/firstrun.groovy
 * scripts/schoolscript/geography.groovy			
 * images/schoolscript/bianca.jpg
 */			
			
// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
